commit e0a211f2ca0f9cce7766166bfa433e0994527a77
Author: freddy77 <freddy77>
Date:   Fri Oct 2 09:24:07 2009 +0000

    Support RPCs using tds 4.2

diff --git a/ChangeLog b/ChangeLog
index ec4152a..b2f4998 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Fri Oct  2 11:23:18 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/ctlib/ct.c src/tds/query.c src/tds/tds_checks.c:
+	- Support RPCs using tds 4.2
+
 Thu Oct  1 11:47:53 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/convert_tds2sql.c src/tds/iconv.c:
 	- Avoid core using SQLWCHAR and TDS 4.2
@@ -1860,4 +1864,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2875 2009/10/01 09:48:43 freddy77 Exp $
+$Id: ChangeLog,v 1.2876 2009/10/02 09:24:07 freddy77 Exp $
diff --git a/src/ctlib/ct.c b/src/ctlib/ct.c
index e7cc8f8..f79f909 100644
--- a/src/ctlib/ct.c
+++ b/src/ctlib/ct.c
@@ -39,7 +39,7 @@
 #include "tdsstring.h"
 #include "replacements.h"
 
-TDS_RCSID(var, "$Id: ct.c,v 1.198 2009/08/18 15:04:13 freddy77 Exp $");
+TDS_RCSID(var, "$Id: ct.c,v 1.199 2009/10/02 09:24:07 freddy77 Exp $");
 
 
 static char * ct_describe_cmd_state(CS_INT state);
@@ -2024,6 +2024,7 @@ _ct_get_server_type(int datatype)
 	case CS_BINARY_TYPE:		return SYBBINARY;
 	case CS_BIT_TYPE:		return SYBBIT;	
 	case CS_CHAR_TYPE:		return SYBCHAR;	
+	case CS_VARCHAR_TYPE:		return SYBVARCHAR;
 	case CS_LONG_TYPE:
 	case CS_BIGINT_TYPE:		return SYBINT8;	
 	case CS_INT_TYPE:		return SYBINT4;	
diff --git a/src/tds/query.c b/src/tds/query.c
index 6723a0b..7200afb 100644
--- a/src/tds/query.c
+++ b/src/tds/query.c
@@ -46,7 +46,7 @@
 
 #include <assert.h>
 
-TDS_RCSID(var, "$Id: query.c,v 1.241 2009/08/26 12:32:11 freddy77 Exp $");
+TDS_RCSID(var, "$Id: query.c,v 1.242 2009/10/02 09:24:08 freddy77 Exp $");
 
 static void tds_put_params(TDSSOCKET * tds, TDSPARAMINFO * info, int flags);
 static void tds7_put_query_params(TDSSOCKET * tds, const char *query, size_t query_len);
@@ -57,6 +57,7 @@ static char *tds7_build_param_def_from_query(TDSSOCKET * tds, const char* conver
 static char *tds7_build_param_def_from_params(TDSSOCKET * tds, const char* query, size_t query_len, TDSPARAMINFO * params, size_t *out_len);
 static size_t tds_fix_column_size(TDSSOCKET * tds, TDSCOLUMN * curcol);
 
+static int tds_put_param_as_string(TDSSOCKET * tds, TDSPARAMINFO * params, int n);
 static int tds_send_emulated_execute(TDSSOCKET * tds, const char *query, TDSPARAMINFO * params);
 static const char *tds_skip_comment(const char *s);
 static int tds_count_placeholders_ucs2le(const char *query, const char *query_end);
@@ -729,6 +730,8 @@ tds_get_column_declaration(TDSSOCKET * tds, TDSCOLUMN * curcol, char *out)
 	case SYBUINT4:
 	case SYBUINT8:
 	case SYBVARIANT:
+	default:
+		tdsdump_log(TDS_DBG_ERROR, "Unknown type %d\n", tds_get_conversion_type(curcol->on_server.column_type, curcol->on_server.column_size));
 		break;
 	}
 
@@ -1854,6 +1857,56 @@ tds_submit_unprepare(TDSSOCKET * tds, TDSDYNAMIC * dyn)
 	return tds_query_flush_packet(tds);
 }
 
+static int
+tds_send_emulated_rpc(TDSSOCKET * tds, const char *rpc_name, TDSPARAMINFO * params)
+{
+	TDSCOLUMN *param;
+	int i, n;
+	int num_params = params ? params->num_cols : 0;
+	const char *sep = " ";
+	char buf[80];
+
+	/* create params and set */
+	for (i = 0, n = 0; i < num_params; ++i) {
+
+		param = params->columns[i];
+
+		/* declare and set output parameters */
+		if (!param->column_output)
+			continue;
+		++n;
+		sprintf(buf, " DECLARE @P%d ", n);
+		tds_get_column_declaration(tds, param, buf + strlen(buf));
+		sprintf(buf + strlen(buf), " SET @P%d=", n);
+		tds_put_string(tds, buf, -1);
+		tds_put_param_as_string(tds, params, i);
+	}
+
+	/* put exec statement */
+	tds_put_string(tds, " EXEC ", 6);
+	tds_put_string(tds, rpc_name, -1);
+
+	/* put arguments */
+	for (i = 0, n = 0; i < num_params; ++i) {
+		param = params->columns[i];
+		tds_put_string(tds, sep, -1);
+		if (param->column_namelen > 0) {
+			tds_put_string(tds, param->column_name, param->column_namelen);
+			tds_put_string(tds, "=", 1);
+		}
+		if (param->column_output) {
+			++n;
+			sprintf(buf, "@P%d OUTPUT", n);
+			tds_put_string(tds, buf, -1);
+		} else {
+			tds_put_param_as_string(tds, params, i);
+		}
+		sep = ",";
+	}
+
+	return tds_query_flush_packet(tds);
+}
+
 /**
  * tds_submit_rpc() call a RPC from server. Output parameters will be stored in tds->param_info
  * \param tds      state information for the socket and the TDS protocol
@@ -1935,7 +1988,10 @@ tds_submit_rpc(TDSSOCKET * tds, const char *rpc_name, TDSPARAMINFO * params)
 		return tds_query_flush_packet(tds);
 	}
 
-	/* TODO emulate it for TDS4.x, send RPC for mssql */
+	/* emulate it for TDS4.x, send RPC for mssql */
+	if (tds->tds_version < 0x500)
+		return tds_send_emulated_rpc(tds, rpc_name, params);
+
 	/* TODO continue, support for TDS4?? */
 	tds_set_state(tds, TDS_IDLE);
 	return TDS_FAIL;
diff --git a/src/tds/tds_checks.c b/src/tds/tds_checks.c
index fbe6857..e24f4e1 100644
--- a/src/tds/tds_checks.c
+++ b/src/tds/tds_checks.c
@@ -44,7 +44,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: tds_checks.c,v 1.27 2009/08/26 12:32:11 freddy77 Exp $");
+TDS_RCSID(var, "$Id: tds_checks.c,v 1.28 2009/10/02 09:24:08 freddy77 Exp $");
 
 #if ENABLE_EXTRA_CHECKS
 
@@ -186,6 +186,7 @@ tds_check_column_extra(const TDSCOLUMN * column)
 	/* I don't like this that much... freddy77 */
 	if (column->column_type == 0)
 		return;
+	assert(column->column_type > 0);
 
 	assert(strlen(column->table_name) < sizeof(column->table_name));
 	assert(strlen(column->column_name) < sizeof(column->column_name));

